#include "smtp.h"

/* smtp->jabber */

char getf[3]="ddd";


/* ensure that data is 7 bit */
char *smtp_mime_check7bit(smtpsi s, mimectx ctx, char *str)
   {
   char *ptr;

   if (!(ctx->mimeEncoding == MIME_7BIT || ctx->mimeEncoding == MIME_QUOTED || ctx->mimeEncoding == MIME_BASE64))
   return str;

   for (ptr=str; ptr && *ptr; ptr++)
  	   *ptr |= 0x7f;

   return str;
   }

/* convert a string to UTF-8 encoding */
char *smtp_mime_toUTF8(smtpsi s, mimectx ctx, char *str)
   {
   char *ptr;

   /* XXX this is not correct handling */
   for (ptr=str; ptr && *ptr; ptr++)
  	   if (*ptr>126 || *ptr<1)
	      *ptr = ' ';

   return str;
   }

/* decode a quoted printable string line */
char *smtp_mime_decode_quoted(smtpsi s, mimectx ctx, char *str)
   {
   char *tmp;
   tmp = (char*)pmalloco(s->p, j_strlen(str));
   fromQP(str, (void *) tmp);
   if (strcasecmp(ctx->mimeCharset, "utf-8")==0)
      return tmp;
   else
      return smtp_mime_toUTF8(s, ctx, tmp);
   }

/* decode a base64 encoded string */
char *smtp_mime_decode_base64(smtpsi s, mimectx ctx, char *str)
   {
   str_b64decode(str);
   if (strcasecmp(ctx->mimeCharset, "utf-8")==0)
      return str;
   else
      return smtp_mime_toUTF8(s, ctx, str);
   }

/* decode a mime encoded string */
char *smtp_mime_decode(smtpsi s, mimectx ctx, char *str)
   {
   if (!ctx->mimeUsed)
	  return str;

   switch (ctx->mimeEncoding)
      {
	  case MIME_7BIT:
//	       smtp_mime_check7bit(s, ctx, str);
	       return str;

 	  case MIME_8BIT:
	       return smtp_mime_toUTF8(s, ctx, str);

	  case MIME_BINARY:
	       /* XXX how to handle binary encoded data? */
	       return smtp_mime_toUTF8(s, ctx, str);

	  case MIME_QUOTED:
	       return smtp_mime_decode_quoted(s, ctx, str);

	  case MIME_BASE64:
	       return smtp_mime_decode_base64(s, ctx, str);

	  default:
	       log_debug(ZONE, "invalid mimeEncoding in mimectx: %i", ctx->mimeEncoding);
	       return smtp_mime_toUTF8(s, ctx, str); // you must remove non ASCII characters
      }
   return str;
   }

/* send an outgoing line to the connection */
void smtp_in_status(smtpp par, int liStatus, char *data)
   {
   char istr[10] = "";
   char *lcOut;
   smtpsi si=par->si;
   pool p;

   sprintf(istr,"%d ",liStatus);
   p = pool_new();
   lcOut = spools(p,istr,data,"\r\n",p);
   #ifdef SMTP_DB
    log_debug(ZONE,"SMTP-OUT: %s",lcOut);
   #else
    log_debug(ZONE,"SMTP-OUT:");
   #endif
   mio_write(si->m,NULL,lcOut,-1);
   pool_free(p);
   }



/* decode the incoming commands */
void smtp_in_cmd(smtpp par, int liCmd, char *addr)
   {
   jid id;
   char *bkt;
   smtpsi si=par->si;
   smtpi sin=par->sin;

   /* we only accept 7 bit characters in SMTP commands */
   for (bkt = addr; bkt && *bkt; bkt++)
	   if (*bkt > 126 || *bkt < 32)
	      *bkt = ' ';

   if (addr != NULL)
      {
      bkt = strstr(addr,"<");
      if (bkt != NULL) addr = bkt + 1;
         bkt = strstr(addr,">");
      if(bkt != NULL) *bkt = '\0';
      }

   log_debug(ZONE,"command %d with data %s",liCmd,addr);

//   log_debug(ZONE,"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\r\n");
//    gets((char *) &getf);

   switch(liCmd)
      {
      case CMD_HELO:
           smtp_in_status(par, 250, "Hi.");
           break;

      case CMD_MAIL:
           si->from = pstrdup(si->p,addr);
           smtp_in_status(par, 250, "Ok");
           break;

      case CMD_RCPT:
           // S:2005-08-31 gorila@dione.zcu.cz
           // Alltrim(), remove spaces from left and right sides
           id = smtp_mx2(sin,jid_new(si->p,smtp_alltrim(addr)));
           // E:2005-08-31 gorila@dione.zcu.cz
           if (id != NULL)
              {
              jid_set(id, addr,JID_RESOURCE); // backup original smtp address as resource
              si->rcpt=(si->rcpt == NULL)?id:jid_append(si->rcpt,id);
              smtp_in_status(par, 250, "Ok");
              }
           else
              {
              smtp_in_status(par, 550, "Bad Address");
              }
              break;

      case CMD_DATA:
           si->phase = PHASE_DATA;
           si->x = xmlnode_new_tag_pool(si->p,"mail");
           smtp_in_status(par, 354, "Feed me");
           break;

      case CMD_RSET:
           si->x = NULL;
           si->rcpt = NULL;
           smtp_in_status(par, 250, "Boring");
           break;

      case CMD_NOOP:
           smtp_in_status(par, 250, "Boring");
           break;
 
      case CMD_QUIT:
           smtp_in_status(par, 221, "Bye");
           break;

  	  default:
           smtp_in_status(par, 500, "Duh");
      }
   }

int smtp_cmd_parse(char *lcCmd)
   {
   log_debug(ZONE, "parsing command %s", lcCmd);

   if(strcasecmp(lcCmd,"HELO") == 0) return CMD_HELO;
   if(strcasecmp(lcCmd,"MAIL") == 0) return CMD_MAIL;
   if(strcasecmp(lcCmd,"RCPT") == 0) return CMD_RCPT;
   if(strcasecmp(lcCmd,"DATA") == 0) return CMD_DATA;
   if(strcasecmp(lcCmd,"NOOP") == 0) return CMD_NOOP;
   if(strcasecmp(lcCmd,"RSET") == 0) return CMD_RSET;
   if(strcasecmp(lcCmd,"QUIT") == 0) return CMD_QUIT;

   return CMD_NONE;
   }


// S:2005-06-03 gorila@dione.zcu.cz
// Return command separator
char *smtp_cmd_sep(int liCmd)
   {
   if(liCmd == CMD_HELO) return " ";
   if(liCmd == CMD_MAIL) return ":";
   if(liCmd == CMD_RCPT) return ":";
   if(liCmd == CMD_DATA) return " ";
   if(liCmd == CMD_NOOP) return " ";
   if(liCmd == CMD_RSET) return " ";
   if(liCmd == CMD_QUIT) return " ";

   return " ";
   }
// E:2005-06-03 gorila@dione.zcu.cz

char *smtp_in_getaddr(pool p, char *str)
   {
   char *cur, *top;
   char invalid[] = "\"'<> \t,";
   int isaddr = 0;

   log_debug(ZONE,"searching for an address in: %s",str);

   for (top = cur = pstrdup(p,str);cur != NULL && *cur != '\0';cur++)
       {
       /* can't grok invalid chars in an address */
       if (index(invalid,*cur) != NULL)
          {
          /* we've hit an invalid char at the end of a valid address, snip it and quit */
          if (isaddr)
             {
             *cur = '\0';
             break;
             }
          top = cur + 1;
          continue;
          }

       /* yay, a @ after some valid chars, it's an address! (or so we hope) */
       if (*cur == '@')
          {
          *cur = '%'; /* escape it, of course */
          isaddr = 1;
          continue;
          }
       }

   if (isaddr)
      {
      log_debug(ZONE,"we've found something we think is an address: %s",top);
      return top;
      }

   log_debug(ZONE,"nothing of concequence found");
   return NULL;
   }

/* when the connection dies, clean up the mess */
void smtp_in_cleanup(void *arg)
   {
   smtpsi si = (smtpsi)(arg);
 
   log_debug(ZONE,"smtp_in_cleanup");
   if (si != NULL)
      free(si->buffer);

   }


/* extract a value from header line*/
char *smtp_in_GetHeaderLineValue(smtpp par, char *lcLine, const char *lcAttrib)
   {
   int liLen;
   char *lcRet,*liS,*liE,*liSX;
   smtpsi si=par->si;

   if (lcAttrib=="") // get basic value
      {
      liS=lcLine;
      liE=strstr(liS,";");
      liLen=(liE==NULL)?j_strlen(lcLine):(int) (liE-liS);
      }
   else // get attrib value
      {
      liS=strstr(lcLine,lcAttrib); // find attrib
      if (liS==NULL) // attrib not found
         return NULL;

      liS=strstr(liS+strlen(lcAttrib),"="); // find =
      if (liS==NULL) // Not found, m po prdeli
         return NULL;

      liSX=strstr(liS+1,"\""); // find "
      if (liSX!=NULL) 
         {
         liS=liSX+1;
         liE=strstr(liS,"\""); // found end of value assignment
         if (liE==NULL) // Not found, m po prdeli
            return NULL;
         }
      else
         {
         liS++;
         liE=strstr(liS,";"); // found end of value assignment
         }

      liLen=(liE==NULL)?(j_strlen(lcLine)- ((int)(liS-lcLine)) ):(liE-liS);
      }

   lcRet = pmalloc(si->p, liLen+1);
   lcRet[liLen] = '\0';
   strncpy(lcRet, liS, liLen);
   return lcRet;
   }

/* extract a header line from the received message */
int smtp_in_header(smtpp par, mimectx ctx, char *msg, char *header, int structured, spool sp, int *liNextLine)
   {
   char *linebegin = msg;
   char *lineend = strchr(linebegin, '\n');
   char *liS,*liE;
   char *tbuf,*ptr;
   size_t hlen,liLen;
   smtpsi si=par->si;
   int liNext=0,liSep,liRow=1,liEnd=0;
   *liNextLine=0;

   if (header == NULL)
	  return 0;

   hlen = strlen(header);

   /* Handle headerlines that are splitted to multible lines */
   while (linebegin && lineend && lineend>linebegin && *linebegin!='\n' && *(linebegin+1)!='\n')
      { /* there is another headerline to process */
      // find while you don't find \r\n\r\n

      liS=linebegin;
      liE=lineend;
      liRow++;

      ptr=strstr(liS,":");
      liSep=((ptr) && ptr<liE)?1:0;

      if (liNext==1 && liSep==1) // next row + detect separator
         {
         *liNextLine=(int)(liS - msg);
         break; //
         }


  	  /* is it the header we are looking for? */
	  if ((liNext==1 && liSep==0) ||
          (strncasecmp(liS, header, hlen)==0 && liS[hlen]==':'))
	     { /* we found the header */


	     liS = liS+(liNext==1?0:hlen)+1;
         if (liE[0]=='\n')
            liE--;

	     /* skip space at the beginning of header content */
	     while (*liS == ' ') liS++;
	     /* skip space at the end of the header content */
	     while (liE[-1] == ' ') liE--;

	     /* empty header? */
	     if (liE <= liS)
		    break;

	     /* return header content */
	     liLen = liE - liS + 1;
	     tbuf = pmalloc(si->p, liLen+1);
	     tbuf[liLen] = '\0';
	     strncpy(tbuf, liS, liLen);
         spooler(sp,tbuf,sp);
         liNext=1;
         // don't return
         // skip to next row
         if (liEnd==1)
            break;

	     }

         
	  /* continue with next header line */
	  linebegin = lineend + 1;
	  lineend = strchr(linebegin, '\n');
      if (lineend==NULL) // End of Data !!!
         {
         lineend=msg+j_strlen(msg)-1;
         liEnd=1;
         }
      }


   if (sp->len==0)
      return 0;

   /* XXX unescape MIME here */
   tbuf=spool_print(sp);

   /* headers are not allowed to contain non-ASCII in encoded form */
   for (ptr = tbuf; *ptr; ptr++)
       if (*ptr > 126 || *ptr < 32) *ptr = ' ';

   /* content in brackets is comment if it is a structured header */
   while (structured && (ptr = strchr(tbuf, '(')) != NULL)
         {
         char *commentend = strchr(ptr, ')');
         if (commentend == NULL)
            *ptr='\0';
         else
            {
		    size_t copylen;
		    size_t i;
		    copylen = strlen(commentend);

		    for (i=0; i<copylen; i++)
			    ptr[i] = commentend[i+1];
		    }
	     }

   sp=spool_new(si->p);
   spooler(sp,tbuf,sp);

   return sp->len;
   }

// parse mail body
char *smtp_in_ParsePGPBody(smtpp par,char *lcBody, xmlnode loCB,const char *lcPart, const char *lcDefPart)
   {
   char *lcCB,*lcStart=NULL;
   log_debug(ZONE,"PGP - parse body ***********************");

   for (;loCB != NULL; loCB = xmlnode_get_nextsibling(loCB))
       {
       // find end of PGP
       if ((lcCB=xmlnode_get_data(loCB)))
          {
          log_debug(ZONE,"CB: %s",lcCB);

          lcStart=strstr(lcBody, spools(par->si->p,"-----",lcPart," ",lcCB,"-----",par->si->p));
          }

       if (lcStart!=NULL)
          break;
       }

   if (lcStart==NULL) // if not cbm or cb elements defined or is not found any cb
       lcStart=strstr(lcBody, lcDefPart);

   log_debug(ZONE,lcStart);

   log_debug(ZONE,"PGP - parse body end ***********************");
   return lcStart;
   }


// parse mail body
int smtp_in_ParseMailBody(smtpp par,mimectx ctx, xmlnode x, char *lcBody, char *lcMBound)
   {
   char *ptr,*lcBoundary, *lcLine, *liS, *liE, *lcTmp, *lcCT, *lcMBody,
        *lcME, *lcDN,*lcProtocol,*liSM;
   int  liNextLine;
   int liLen,liAttach=0;
   smtpsi si=par->si;
   spool tmpsp;
   xmlnode loBody;
   // text/plain
   // ostatn pevst na utf-8 a pak na base64 + pidat pvodn type

   // multipart/mixed??
   // multipart/alternative??
   //  najt text/plain

   // 1. content type uruje tlo mailu
   // Content-type: multipart/alternative; boundary="gc0p4J:2408t"
   // nachzej se dal sti (text, html, soubory)

   // dal content typy uvnit tla uruj jednotliv sti
   // --gc0p4J:2408t
   // Content-type: plain/text; charset=
   // Content-type: plain/html; charset=

   // --gc0p4J:2408t--
   // konec tla sti

   // content type


   log_debug(ZONE,"BODY - get content-type");
   if (smtp_in_header(par, ctx, lcBody, "Content-Type", 0,tmpsp=spool_new(par->si->p),&liNextLine)==0)
      return 0;


   lcMBody=strstr((lcBody+liNextLine), "\n\n"); // Find Data section
 
   lcLine=spool_print(tmpsp);
   lcCT=smtp_in_GetHeaderLineValue(par,lcLine,""); // get basic value

   // check if is't multipart or  alternative
   if (strncasecmp(lcCT,"multipart/mixed",15)==0 ||
       strncasecmp(lcCT,"multipart/alternative",21)==0 ||
       strncasecmp(lcCT,"multipart/parallel",18)==0 ||
       strncasecmp(lcCT,"multipart/encrypted",19)==0 ||
       strncasecmp(lcCT,"multipart/signed",16)==0
      )
      {
      log_debug(ZONE,"BODY - get protocol");
      lcProtocol=smtp_in_GetHeaderLineValue(par,lcLine,"protocol"); // get protocol value

      if (si->iPGP==0 && strncasecmp(lcProtocol,"application/pgp-encrypted",25)==0) // PGP encrypted
         si->iPGP=1;

      if (si->iPGP==0 && strncasecmp(lcProtocol,"application/pgp-signature",25)==0) // PGP signed
         si->iPGP=2;

      log_debug(ZONE,"PGP - protocol %i",si->iPGP);

      lcBoundary=smtp_in_GetHeaderLineValue(par,lcLine,"boundary");
      ptr=strstr(lcMBody,lcBoundary);

      while ( !(ptr[j_strlen(lcBoundary)]=='-' && ptr[j_strlen(lcBoundary)+1]=='-')  )
            {
            // reset for each boundary
            ctx->mimeEncoding = MIME_7BIT;
            ctx->mimeCharset = "us-ascii";

            smtp_in_ParseMailBody(par, ctx, x, ptr,lcBoundary );
            ptr=strstr(ptr+j_strlen(lcBoundary),lcBoundary);
            }
      return 1;
      }

   ctx->mimeEncoding = MIME_7BIT;
   ctx->mimeCharset = "us-ascii";

   loBody=xmlnode_get_tag(x,"body");
   xmlnode_insert_cdata(loBody,"\r\n",-1);

   // encoding for data
   log_debug(ZONE,"BODY - get content-transfer-encoding");
   if (smtp_in_header(par, ctx, lcBody, "Content-Transfer-Encoding", 0,tmpsp=spool_new(par->si->p),&liNextLine)>0)
      {
      lcME=ptr=spool_print(tmpsp);

      if (!ptr)
         ctx->mimeEncoding = MIME_7BIT;
      else if (!strcasecmp(ptr, "8bit"))
         ctx->mimeEncoding = MIME_8BIT;
      else if (!strcasecmp(ptr, "7bit"))
         ctx->mimeEncoding = MIME_7BIT;
      else if (!strcasecmp(ptr, "quoted-printable"))
         ctx->mimeEncoding = MIME_QUOTED;
      else if (!strcasecmp(ptr, "base64"))
  	     ctx->mimeEncoding = MIME_BASE64;
      else if (!strcasecmp(ptr, "binary"))
         ctx->mimeEncoding = MIME_BINARY;
      }

   // Is't file part? (ignore pgp)
   if (si->iPGP==0 && 
       smtp_in_header(par, ctx, lcBody, "Content-Disposition", 0,tmpsp=spool_new(par->si->p),&liNextLine)>0)
      {
      log_debug(ZONE,"BODY - is not PGP, it's maybe file part");

	  lcDN=smtp_in_GetHeaderLineValue(par,lcLine,"name"); // get display name for attachment
      lcLine=spool_print(tmpsp);

      if ((ptr=smtp_in_GetHeaderLineValue(par,lcLine,"")) && 
          (ptr=smtp_in_GetHeaderLineValue(par,lcLine,"filename")) &&
          j_strlen(ptr)>0
         )
         {
         liAttach=1; // yes it's file part
         if (lcDN)
            {
            log_debug(ZONE,"BODY - file part");
            xmlnode_insert_cdata(loBody,"Display name: ",-1);
            xmlnode_insert_cdata(loBody,lcDN,-1);
            xmlnode_insert_cdata(loBody,"\r\n",-1);
            }

         xmlnode_insert_cdata(loBody,"file: ",-1);
         xmlnode_insert_cdata(loBody,ptr,-1);
         xmlnode_insert_cdata(loBody,"\r\n",-1);

         xmlnode_insert_cdata(loBody,"Transfer encoding: ",-1);
         xmlnode_insert_cdata(loBody,lcME,-1);
         xmlnode_insert_cdata(loBody,"\r\n",-1);

         }
      }
   else
      {
      }

   if (liAttach==0 && (ptr=smtp_in_GetHeaderLineValue(par,lcLine,"charset")))
      ctx->mimeCharset = ptr; // charset encoding


   // read boundary data
   log_debug(ZONE,"BODY - read boundary data");
   liS=strstr(lcMBody,"\n\n");  // toto je u mon zbyten
   if (j_strlen(lcMBound)>0)
      {
      liE=strstr(liS, lcMBound); // find next/end of boundary
      liLen=liE-2-(liS+2);
      }
   else
      {
      liLen=j_strlen(lcBody)-(liS+2-lcBody);
      }


   // move data if...
   if (si->iPGP>=1 || 
       (si->iPGP==0 && ((liAttach==1 && par->sin->attachments==1) || liAttach==0))
      )
      {
      log_debug(ZONE,"BODY - create copy of boudary data");
      lcTmp = pmalloc(par->si->p, liLen+1);
      lcTmp[liLen] = '\0';
      strncpy(lcTmp, liS+2, liLen);
      }


   if (si->iPGP==2 || (si->iPGP==0 && liAttach==0)) // text only, signed message
      {

      if (si->iPGP==0 && j_atoi(xmlnode_get_attrib(xmlnode_get_tag(par->sin->config,"pgp"), "nonmime2x"),0)==1)
         {
         log_debug(ZONE,"BODY - test inline PGP");

         if (smtp_in_ParsePGPBody(par,lcTmp,xmlnode_get_tag(par->sin->config,"pgp/cbm/cb"),"BEGIN","-----BEGIN PGP MESSAGE-----"))
            {
  		    si->iPGP=3;
            log_debug(ZONE,"BODY - inline PGP MESSAGE");
            }
         else
            {
            // try find pgp signed message
            if ((liSM=smtp_in_ParsePGPBody(par,lcTmp,xmlnode_get_tag(par->sin->config,"pgp/cbs/cb"),"BEGIN","-----BEGIN PGP SIGNATURE-----")))
               {
               si->iPGP=4;
               log_debug(ZONE,"BODY - inline PGP SIGNATURE");
               }
            }
         }

      if (si->iPGP==0 ||                    
          (si->iPGP==2 && strncasecmp(lcCT,"application/pgp-signature",25)!=0)
          ) // text only, signed but text boundary
         {
         log_debug(ZONE,"BODY - text only, signed but text boundary %s",lcTmp);
         xmlnode_insert_cdata(loBody,smtp_mime_decode(par->si, ctx, lcTmp),-1);
         return 1;
         }
      }

   if (si->iPGP==0 && liAttach==1) // attachment only
      {
      log_debug(ZONE,"BODY - non PGP, any attachment");
      if (par->sin->attachments==1)
         {
         if (ctx->mimeEncoding == MIME_8BIT)
            smtp_mime_decode(par->si, ctx, lcTmp);

         xmlnode_insert_cdata(loBody,lcTmp,-1);
         }

      return 1;
      }

   if (si->iPGP==1 || si->iPGP==3) // PGP encrypted
      {
      log_debug(ZONE,"BODY - PGP MESSAGE");
      xmlnode_put_attrib(loBody=xmlnode_insert_tag(x,"x"),"xmlns","jabber:x:encrypted");

      // decode data
      lcTmp=smtp_mime_decode(par->si, ctx, lcTmp);
      log_debug(ZONE,"PGP - data: %s",lcTmp);

      // locate empty row after -----BEGIN PGP MESSAGE-----
      if ((liE=strstr(lcTmp,"\n \n"))==NULL)
         {
         liE=strstr(lcTmp,"\n\n");  // locate empty row after -----BEGIN PGP MESSAGE-----
         lcTmp=liE+2;
         }
      else
         lcTmp=liE+3;

      liE=smtp_in_ParsePGPBody(par,lcTmp,xmlnode_get_tag(par->sin->config,"pgp/cbs/cb"),"END","-----END PGP MESSAGE-----");

      if (liE)
         liE[0]='\0';

      xmlnode_insert_cdata(loBody,lcTmp,-1);
      return 1;
      }


   if (si->iPGP==2 || si->iPGP==4) // PGP signed
      {
      lcTmp=smtp_mime_decode(par->si, ctx, lcTmp);
      log_debug(ZONE,"BODY - PGP SIGNED %s",lcTmp);
      
      // liSM is begin of PGP signature
      // Find -----BEGIN PGP SIGNED MESSAGE-----
      if (si->iPGP==4)
	     {
   	     ptr=strstr(lcTmp,"-----BEGIN PGP SIGNED MESSAGE-----");
         log_debug(ZONE,"----\r\n %s",ptr);

 		 if (ptr != NULL)
		 	{
			log_debug(ZONE,"00000000000");

			if ((liE=strstr(ptr,"\n \n"))==NULL)  // locate empty row after -----BEGIN PGP SIGNATURE-----
				{
				liE=strstr(ptr,"\n\n");  // locate empty row after -----BEGIN PGP SIGNATURE-----
				ptr=liE+2;
				log_debug(ZONE,"00000000001");
				}
			else
				{
				ptr=liE+3;
				log_debug(ZONE,"00000000002");
				}


			liSM--;
			liSM[0]='\0';
			liSM++;
			log_debug(ZONE,"00000000003");
			xmlnode_insert_cdata(loBody,smtp_mime_decode(par->si, ctx, ptr),-1);
			}
		 }
	  else
	     {
         liSM=lcTmp;
		 }


      log_debug(ZONE,"00000000004");
      loBody=xmlnode_insert_tag(x,"x");
      log_debug(ZONE,"00000000005 %s",xmlnode2str(loBody));
      xmlnode_put_attrib(loBody,"xmlns","jabber:x:signed");
      log_debug(ZONE,"000000000051");


      // locate empty row after -----BEGIN PGP SIGNATURE-----
      if ((liE=strstr(liSM,"\n \n"))==NULL)
         {
         log_debug(ZONE,"00000000006 %s",liSM);

		 liE=strstr(liSM,"\n\n");  // locate empty row after -----BEGIN PGP SIGNATURE-----
         log_debug(ZONE,"00000000006-1 %s",liE);
         lcTmp=liE+2;
         log_debug(ZONE,"00000000006-2 %",lcTmp);
         log_debug(ZONE,"PGP - signature: %s",lcTmp);
         }
      else
         {
  	     log_debug(ZONE,"00000000006x");
         lcTmp=liE+3;
         }

	  log_debug(ZONE,"00000000007");

      liE=smtp_in_ParsePGPBody(par,lcTmp,xmlnode_get_tag(par->sin->config,"pgp/cbs/cb"),"END","-----END PGP SIGNATURE-----");

      log_debug(ZONE,"00000000008");
      if (liE)
         liE[0]='\0';

      log_debug(ZONE,"00000000009");
      xmlnode_insert_cdata(loBody,lcTmp,-1);
      return 1;
      }

   return 0;
   }

void smtp_in_message(smtpp par)
   {
   jid cur;
   xmlnode x, thread,addresses,address,loSubj;
   char *from,*msg,*body,*ptr,*data,*listto,*listcc, *subject, *subjectCP, *subjectE, *lcRepl;
   int  liNextLine;
   _mimectx ctx;
   time_t now_unixtime;
   struct tm now;
   char thread_data[30];
   smtpsi si=par->si;
   smtpi  sin=par->sin;
   int liSpam=0;
   int liType=0;
   spool tmpsp,xxxxxx;
  
   si->iPGP=0;

   sin->MessagesElapsedSMTP++;
   smtp_StatsInc(par, "messagessmtp");


   /* init the mime context to not using MIME */
   ctx.mimeUsed = 0;
   ctx.mimeEncoding = MIME_7BIT;
   ctx.mimeCharset = "us-ascii";

   msg = spool_print(si->message);

/*
   xxxxxx=spool_new(si->p);
spooler(xxxxxx,"Return-Path: <michal.vaner@kdemail.net>\r\n",xxxxxx);
spooler(xxxxxx,"Delivered-To: njs.netlab.cz-pinky@njs.netlab.cz\r\n",xxxxxx);
spooler(xxxxxx,"Received: (qmail 10596 invoked from network); 1 Aug 2006 20:25:30 -0000\r\n",xxxxxx);
spooler(xxxxxx,"Received: from unknown (HELO apelsin.fruitsalad.org) (81.16.160.116)\r\n",xxxxxx);
spooler(xxxxxx,"  by nezmar.netlab.cz with SMTP; 1 Aug 2006 20:25:30 -0000\r\n",xxxxxx);
spooler(xxxxxx,"Received: from localhost (localhost [127.0.0.1])\r\n",xxxxxx);
spooler(xxxxxx,"	by apelsin.fruitsalad.org (Postfix) with ESMTP id 43F5617BB6C4\r\n",xxxxxx);
spooler(xxxxxx,"	for <pinky@njs.netlab.cz>; Tue,  1 Aug 2006 22:24:16 +0200 (CEST)\r\n",xxxxxx);
spooler(xxxxxx,"Received: from localhost (localhost [127.0.0.1])\r\n",xxxxxx);
spooler(xxxxxx,"	by apelsin.fruitsalad.org (Postfix) with ESMTP id 175A617BB66E\r\n",xxxxxx);
spooler(xxxxxx,"	for <pinky@njs.netlab.cz>; Tue,  1 Aug 2006 22:24:16 +0200 (CEST)\r\n",xxxxxx);
spooler(xxxxxx,"Received: from apelsin.fruitsalad.org ([127.0.0.1])\r\n",xxxxxx);
spooler(xxxxxx," by localhost (apelsin.fruitsalad.org [127.0.0.1]) (amavisd-new, port 10024)\r\n",xxxxxx);
spooler(xxxxxx," with ESMTP id 14688-09 for <pinky@njs.netlab.cz>;\r\n",xxxxxx);
spooler(xxxxxx," Tue,  1 Aug 2006 22:24:15 +0200 (CEST)\r\n",xxxxxx);
spooler(xxxxxx,"Received: from localhost (242-170-150-82.gw.cz [82.150.170.242])\r\n",xxxxxx);
spooler(xxxxxx,"	by apelsin.fruitsalad.org (Postfix) with ESMTP id 9BBE717BB26F\r\n",xxxxxx);
spooler(xxxxxx,"	for <pinky@njs.netlab.cz>; Tue,  1 Aug 2006 22:24:14 +0200 (CEST)\r\n",xxxxxx);
spooler(xxxxxx,"Date: Tue, 1 Aug 2006 22:21:51 +0200\r\n",xxxxxx);
spooler(xxxxxx,"From: Michal vorner Vaner <michal.vaner@kdemail.net>\r\n",xxxxxx);
spooler(xxxxxx,"To: pinky@njs.netlab.cz\r\n",xxxxxx);
spooler(xxxxxx,"Subject: killer\r\n",xxxxxx);
spooler(xxxxxx,"Message-ID: <20060801202151.GC18806@tarantula>\r\n",xxxxxx);
spooler(xxxxxx,"Reply-To: Michal vorner Vaner <michal.vaner@kdemail.net>\r\n",xxxxxx);
spooler(xxxxxx,"Mime-Version: 1.0\r\n",xxxxxx);
spooler(xxxxxx,"Content-Type: multipart/signed; micalg=pgp-sha1;\r\n",xxxxxx);
spooler(xxxxxx,"	protocol=\"application/pgp-signature\"; boundary=\"raC6veAxrt5nqIoY\"\r\n",xxxxxx);
spooler(xxxxxx,"Content-Disposition: inline\r\n",xxxxxx);
spooler(xxxxxx,"Jabber-ID: michal.vaner@njs.netlab.cz\r\n",xxxxxx);
spooler(xxxxxx,"User-Agent: Mutt 1.5.11 (2005-09-15)\r\n",xxxxxx);
spooler(xxxxxx,"X-Virus-Scanned: by amavisd-new at kdemail.net\r\n",xxxxxx);
spooler(xxxxxx,"\r\n",xxxxxx);
spooler(xxxxxx,"\r\n",xxxxxx);
spooler(xxxxxx,"--raC6veAxrt5nqIoY\r\n",xxxxxx);
spooler(xxxxxx,"Content-Type: text/plain; charset=us-ascii\r\n",xxxxxx);
spooler(xxxxxx,"Content-Disposition: inline\r\n",xxxxxx);
spooler(xxxxxx,"Content-Transfer-Encoding: quoted-printable\r\n",xxxxxx);
spooler(xxxxxx,"\r\n",xxxxxx);
spooler(xxxxxx,"Killer, on the road...\r\n",xxxxxx);
spooler(xxxxxx,"\r\n",xxxxxx);
spooler(xxxxxx,"--=20\r\n",xxxxxx);
spooler(xxxxxx,"This email has not been checked by an antivirus system.\r\n",xxxxxx);
spooler(xxxxxx,"No virus found.\r\n",xxxxxx);
spooler(xxxxxx,"\r\n",xxxxxx);
spooler(xxxxxx,"Michal \"vorner\" Vaner\r\n",xxxxxx);
spooler(xxxxxx,"\r\n",xxxxxx);
spooler(xxxxxx,"--raC6veAxrt5nqIoY\r\n",xxxxxx);
spooler(xxxxxx,"Content-Type: application/pgp-signature\r\n",xxxxxx);
spooler(xxxxxx,"Content-Disposition: inline\r\n",xxxxxx);
spooler(xxxxxx,"\r\n",xxxxxx);
spooler(xxxxxx,"-----BEGIN PGP SIGNATURE-----\r\n",xxxxxx);
spooler(xxxxxx,"Version: GnuPG v1.4.4 (GNU/Linux)\r\n",xxxxxx);
spooler(xxxxxx,"\r\n",xxxxxx);
spooler(xxxxxx,"iD8DBQFEz7ff7/oWwynB3bIRAnKtAKCHVNsXqBEXfuoD6LHRyqNU1b3tZwCdEuPv\r\n",xxxxxx);
spooler(xxxxxx,"X12DspjEEgueyWJNT8J8bJ0=\r\n",xxxxxx);
spooler(xxxxxx,"=g6IX\r\n",xxxxxx);
spooler(xxxxxx,"-----END PGP SIGNATURE-----\r\n",xxxxxx);
spooler(xxxxxx,"\r\n",xxxxxx);
spooler(xxxxxx,"--raC6veAxrt5nqIoY--\r\n",xxxxxx);
   msg = spool_print(xxxxxx);
*/
   #ifdef SMTP_DB
   log_debug(ZONE,"DATA - I got a message! \r\n%s",msg);
   #else
   log_debug(ZONE,"DATA - I got a message!");
   #endif

   // spam checking
   liSpam=smtp_in_spam(par,msg);

   if (!(liSpam==SPAM_OK || liSpam==SPAM_NotDefined))
      return;

   /* normalize line breaks to '\n' only */
   log_debug(ZONE,"DATA - normalize line breaks");
   while ((ptr = strstr(msg, "\r\n")) != NULL)
      {
      strcpy(ptr, ptr+1);
      }

   while ((ptr = strchr(msg, '\r')) != NULL)
      {
	  *ptr = '\n';
      }


   // is this a message that uses MIME? 
   if (smtp_in_header(par, &ctx, msg, "MIME-Version", 1,tmpsp=spool_new(si->p),&liNextLine)>0)
	  ctx.mimeUsed = 1;


   x = xmlnode_new_tag("message");
   cur = jid_new(xmlnode_pool(x),sin->i->id); // jabber sending domain is based on configured service id

   log_debug(ZONE,"DATA - reading sender");
   // set the sending email addr frist from the reply-to, then the sender, then finally the addr smtp claims it was from 
   if (smtp_in_header(par, &ctx, msg, "Reply-To", 1,tmpsp=spool_new(si->p),&liNextLine)>0)
      from = smtp_in_getaddr(si->p,spool_print(tmpsp));
   else   
      if (smtp_in_header(par, &ctx, msg, "From", 1,tmpsp=spool_new(si->p),&liNextLine)>0)
         from = smtp_in_getaddr(si->p,spool_print(tmpsp));
      else   
         from = smtp_in_getaddr(si->p, si->from);


   jid_set(cur,from,JID_USER);
   xmlnode_put_attrib(x,"from",jid_full(cur));


   // subject can be encoded in quoted printable or base64 +code page
   // Subject: =?iso-8859-2?B?dGVzdOg=?=
   //          xxCodePage  xExdata    ?=
   // E==Q - quoted printable
   // E==B - base64

   log_debug(ZONE,"DATA - reading subject");
   loSubj=xmlnode_get_tag(par->sin->config,"subject");
   if ( loSubj && (lcRepl=xmlnode_get_attrib(loSubj,"replace")))
      {}

   if (smtp_in_header(par,&ctx,  msg, "Subject", 0,tmpsp=spool_new(si->p),&liNextLine)>0)
      {
      subject=spool_print(tmpsp); 
      ctx.mimeEncoding = MIME_8BIT;

      log_debug(ZONE,"DATA - subject check encode algorithm");
      // Check codepage and encode algorithm
      if ((subjectCP=strstr(subject,"=?"))!=NULL)
         {
         ctx.mimeCharset=subjectCP=subjectCP+2; // begin of code page
   
         subjectE=strstr(subjectCP,"?");
         subjectE++; // begin of encode

         subject=strstr(subjectE,"?");
         subject++; // begin of subject data
         ptr=strstr(subject,"?");
         if (ptr!=NULL)
            *ptr='\0';

         if (!strncasecmp(subjectE, "Q",1))
            ctx.mimeEncoding = MIME_QUOTED;
         else if (!strncasecmp(subjectE, "B",1))
            ctx.mimeEncoding = MIME_BASE64;
         else 
            ctx.mimeEncoding = MIME_7BIT;
         }

      log_debug(ZONE,"DATA - subject decode");
      subject=smtp_mime_decode(si, &ctx, subject);

      if (loSubj && lcRepl && strcmp(lcRepl,"0")!=0)
         {
         log_debug(ZONE,"DATA - replace subject");
         if (j_strlen(subject)==0 && strncmp(lcRepl,"3",1)==0) // if empty and replace is 3
            subject=spools(si->p,xmlnode_get_data(loSubj),si->p);

         if (j_strlen(subject)>0 && strncmp(lcRepl,"1",1)==0) // if not empty and replace is 1
            subject=spools(si->p,xmlnode_get_data(loSubj),xmlnode_get_attrib(loSubj,"separator"),subject,si->p);

         if (j_strlen(subject)>0 && strncmp(lcRepl,"2",1)==0) // if not empty and replace is 2
            subject=spools(si->p,subject,xmlnode_get_attrib(loSubj,"separator"),xmlnode_get_data(loSubj),si->p);

         }
   
      xmlnode_insert_cdata(xmlnode_insert_tag(x,"subject"),subject,-1);
      }
   else
      {
      if (loSubj && lcRepl && strcmp(lcRepl,"3")==0)
	     {
		 xmlnode_insert_cdata(xmlnode_insert_tag(x,"subject"),spools(si->p,xmlnode_get_data(loSubj),si->p),-1);
		 }
   
      }

   // thread-id
   log_debug(ZONE,"DATA - reading thread ID");
   if (smtp_in_header(par, &ctx, msg, "X-Jabber-Thread-id", 0,tmpsp=spool_new(si->p),&liNextLine)>0)
      {
      data=spool_print(tmpsp);
      thread=xmlnode_insert_tag(x,"thread");
      xmlnode_put_attrib(x,"type","chat");
      if (strcmp(data,"jabber-start-thread")==0)
         {
         now_unixtime = time(NULL);
         gmtime_r(&now_unixtime, &now);
         thread_data[0]='\0';
         snprintf(thread_data, sizeof(thread_data), "JPT_%04i%02i%02i%02i%02i%02i%i", now.tm_year+1900, now.tm_mon, now.tm_mday, now.tm_hour, now.tm_min, now.tm_sec, rand());
         xmlnode_insert_cdata(thread,thread_data,-1);
         }
      else
         xmlnode_insert_cdata(thread,data,-1);
      }


   log_debug(ZONE,"DATA - message ID");
   if (smtp_in_header(par, &ctx, msg, "Message-ID", 0,tmpsp=spool_new(si->p),&liNextLine)>0)
      xmlnode_put_attrib(x,"id",smtp_lgstrim(spool_print(tmpsp)));

   if (ctx.mimeUsed == 1)
      {
      log_debug(ZONE,"DATA - MIME mode");
      xmlnode_insert_tag(x,"body");
      smtp_in_ParseMailBody(par, &ctx,x, msg,"");
      }
   else
      {
      log_debug(ZONE,"DATA - NONMIME mode");
      body = strstr(msg, "\n\n");
      smtp_mime_decode(si, &ctx, body);
      xmlnode_insert_cdata(xmlnode_insert_tag(x,"body"),body,-1);
      }
    
   // find first line with cc
   log_debug(ZONE,"DATA - get carbon copy");
   if (smtp_in_header(par, &ctx, msg, "cc", 0,tmpsp=spool_new(si->p),&liNextLine)>0)
      {
      listcc =spool_print(tmpsp);
      #ifdef SMTP_DB
       log_debug(ZONE,"DATA - sending carbon copy: %s",listcc);
      #else
       log_debug(ZONE,"DATA - sending carbon copy");
      #endif
      }

   // find first line with to
   log_debug(ZONE,"DATA - get listto");
   if (smtp_in_header(par, &ctx, msg, "to", 0,tmpsp=spool_new(si->p),&liNextLine)>0)
      {
      listto =spool_print(tmpsp);
      #ifdef SMTP_DB
       log_debug(ZONE,"DATA - sending listto: %s",listto);
      #else
       log_debug(ZONE,"DATA - sending listto");
      #endif
      }

   log_debug(ZONE,"DATA - JEP-0033 support");
   if (sin->jep0033==1) // JEP-0033 support
      {
      xmlnode_put_attrib(x,"to",cur->server); // jabber server
      xmlnode_put_attrib(addresses=xmlnode_insert_tag(x,"addresses"),"xmnls","http://jabber.org/protocol/address");

      for (cur = si->rcpt ; cur != NULL; cur = cur->next)
          {
          liType=2;
          if (strstr(listcc,cur->resource)) // is in cc list?
             liType=0;

          if (strstr(listcc,cur->resource)) // is in to list?
             liType=1;

          cur->resource=NULL;
          xmlnode_put_attrib(address=xmlnode_insert_tag(addresses,"address"),"jid",jid_full(cur));

          if (liType==0) // is in cc list?
             {
             log_debug(ZONE,"DATA - sending to (cc) %s",jid_full(cur));
             xmlnode_put_attrib(address,"type","cc");
             }

          if (liType==1) // is in to list?
             {
             log_debug(ZONE,"DATA - sending to (to) %s",jid_full(cur));
             xmlnode_put_attrib(address,"type","to");
             }

          if (liType==2)
             {
             log_debug(ZONE,"DATA - sending to (bcc) %s",jid_full(cur));
             xmlnode_put_attrib(address,"type","bcc");
             }
          }

      deliver(dpacket_new(xmlnode_dup(x)),sin->i);
      }
   else
      {
      for (cur = si->rcpt; cur != NULL; cur = cur->next)
          {
          cur->resource=NULL;
          log_debug(ZONE,"DATA - sending to %s",jid_full(cur));
          xmlnode_put_attrib(x,"to",jid_full(cur));
          deliver(dpacket_new(xmlnode_dup(x)),sin->i);
          }
      }


   log_debug(ZONE,"DATA - Increment counter");
   sin->MessagesElapsedOut++;
   smtp_StatsInc(par, "messagesin");

   xmlnode_free(x);
   smtp_in_status(par,250,"Message Accepted");
   }

/* read an incoming line from the connection */
void smtp_in_read(mio m, int state, void *arg, char *buffer,int bufsz)
   {
   char *cbuffer, *cur, *cur_, *args;
   smtpi sin;
   smtpp par;
   smtpsi si;
   int i, cmd;

   switch(state)
      {
      case MIO_NEW:
           sin = (smtpi) (arg);
           par = smtp_param(sin);
           par->si= si = smtp_new_i(m);
           si->phase = PHASE_CMD;
           si->host = mio_ip(m);
           log_debug(ZONE,"new connection from %s",si->host);
           smtp_in_status(par,220,"Jabber SMTP Transport");
           pool_cleanup(si->p, smtp_in_cleanup, (void *)si);
           mio_reset(m, smtp_in_read, (void *)par);
           return;

      case MIO_BUFFER:
           par=(smtpp)(arg);
           si=par->si;
           break;

      default:
           return;
      }

   si->timer = time(NULL); /* so we don't timeout */

   if (bufsz <= 0) return;

   /* XXX fix special characters, need more intelligence here */
   /*
   for(cur = buffer; (cur - buffer) < bufsz; cur++)
       if(*cur == 127 || (*cur < 32 && *cur != 10 && *cur != 13))
           *cur = '*';
   */


   // S:2005-06-02 gorila@dione.zcu.cz
   // Convert \0 to space
   for(i = 0; i < bufsz; i++)
      {
      if (buffer[i] == '\0') buffer[i]=' ';
	  }
   // E:2005-06-02 gorila@dione.zcu.cz


   if (si->buffer != NULL)
      { /* old data yet, combine and use that */
      cur = malloc(strlen(si->buffer) + bufsz + 1);
      *cur = '\0';
      strcat(cur,si->buffer);
      strcat(cur,buffer);
      free(si->buffer);
      si->buffer = buffer = cur;
      bufsz = strlen(buffer);
      }

   #ifdef SMTP_DB
    log_debug(ZONE,"phase %d data [%s]",si->phase, buffer);
   #else
    log_debug(ZONE,"phase %d data",si->phase);
   #endif

   cur = cbuffer = (char *)buffer;
   for (i = 1; i < bufsz; i++)
       {
       if (cbuffer[i-1] == '\r' && cbuffer[i] == '\n')
          {
          cbuffer[i-1] = '\0';
          cbuffer[i] = '\0';
          if (si->phase == PHASE_CMD)
             {
             if (strlen(cur) > 0)
                {
                // S:2005-06-03 gorila@dione.zcu.cz
                // Better command detection

                cur_=cur;
                // find "end" of command
                args = strstr(cur, " ");
                if(args != NULL) *args = '\0';
                
                // Get ID Command
                cmd=smtp_cmd_parse(cur);
                if(args != NULL) *args = ' ';

                cur=cur_;

                // Find argument
                args = strstr(cur, smtp_cmd_sep(cmd));
                if (args != NULL)
                   {
                   *args = '\0';
                   ++args;
                   }

                // Process command
                smtp_in_cmd(par, cmd, args);
                // E:2005-06-03 gorila@dione.zcu.cz
                }
             }
          else 
             if (si->phase == PHASE_DATA)
                {
                if (*cur == '.')
                   {
                   ++cur;
                   if (strlen(cur) == 0)
                      {
                      smtp_in_message(par);
                      si->x = NULL;
                      si->rcpt = NULL;
                      si->phase = PHASE_CMD;
                      }
                   }

                if (si->phase == PHASE_DATA && cur)
                   {
		           spooler(si->message, cur, "\r\n", si->message);
                   }
                }

          cur = cbuffer + i + 1;
          }
       }

   cbuffer = NULL;
   i = strlen(cur);
   if (i > 0) /* the read was cut off */
      {
	  if (i > 514)
	     {
	     smtp_in_status(par,500,"XXX too much data");
	     }
      else
         {
         cbuffer = strdup(cur);
         }
      }

   free(si->buffer);
   si->buffer = cbuffer; /* save the tail from above, if any */
   }

